#!/bin/sh

# Copyright 2014, 2021 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

locktimeout=900
. "$_EXEC"/session_lock.sh

uid="$(timeid)$(randomid)"  # 32 Octets UID, starting with timestamp
course="${uid}.ics"

tzid="$(cat /etc/timezone)"
tstamp="$(TZ="$tzid" date +%Y%m%dT%H%M%S)"

coursefile="$_DATA/ical/$course"

if tempfile="$(SLOCK "$coursefile")"; then
  cat >"$tempfile" <<-EOF
	BEGIN:VCALENDAR
	VERSION:2.0
	PRODID:Berlin RAW Confetti
	BEGIN:VEVENT
	UID:$uid
	DTSTAMP:TZID=${tzid}:${tstamp}
	DTSTART:TZID=${tzid}:${tstamp}
	DURATION:
	RRULE:
	SUMMARY:
	COMMENT:
	END:VEVENT
	END:VCARD
	EOF
  REDIRECT "/courses/?e=${course}"
else
  SET_COOKIE session message="EDITLOCK"
  REDIRECT "/courses/"
fi
